#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ipc.h>
#include "wisio.h"

int loaderqueue=MAINQUE;
int *queues=NULL;
int mypid=-1,
    halt=0,
    msg_to_rec=MSG_TYPALL,
    msg_to_send=MSG_TYPCMD,
    maxqueues=MAXPS;
int myparent;
int msg_to_ret=MSG_TYPRET;
int timer=0;
int retries=20;
int nbits[8]={0,1,2,4,8,16,32};
//char bm[8]={1,4,0,7,1,15,1,31};
int Wactive = 0;
int Wloglevel=0;
int Wlog(int level,char *format,...)
{
#ifdef WLOG
    int *p;
    FILE *F;
    char name[20];

    if (Wloglevel < level) 
       return;
    sprintf(name,"Wlog%d",level);
    F=fopen(name,"a");
    fprintf(F,"WLOG:%d  ",mypid);
    p=(int*)&format;
    fprintf(F,format,p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9],p[10]);
    fprintf(F,"\n");
    fclose(F);
#endif
}
int Wsend(int pid, msg_win_cmd *pmes, int len)
{
   int i,res,waittime;
   if (pid<0 || pid >=maxqueues)
      return -1;
   if (queues[pid]==-1)
   {
      queues[pid]=msgget(BASEQUE+pid,0666|IPC_CREAT);
   }
   i=retries;
   waittime = 1;
   do
   {
      res=msgsnd(queues[pid],pmes,len,IPC_NOWAIT);
      Wlog(42,"SEND %d %d",pid,res);
      if (res!=-1)
         break;
      usleep(waittime*=2);
   }
   while (i-->0);
    
}
/*
int Wsendcmd(int des,int cmd,int cid, int idx, int flag,int x, int y,int dx, int dy,int co, 
             char *data,datalen)*/
             
int Wsendcmd(int des,...)
{
   int dummy[64];
   msg_win_cmd mes;
   int *p,size,res,dq,i;
   char *s;

   p=&des;
   if (*p < 0)
      return(-1);
   dq = *p++;
/*   if (queues[dq]==-1)
   {
      queues[dq]=msgget(BASEQUE+dq,0666|IPC_CREAT);
   }*/
      
   mes.des = msg_to_send;   
   mes.pid = mypid;
   if (*p <=0)
      return(-1);
   mes.cmd = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,cmd);
   else{
   mes.cid = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,cid);
   else{
   mes.idx = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,idx);
   else{
   mes.flg = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,flg);
   else{
   mes.x   = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,x);
   else{
   mes.y   = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,y);
   else{
   mes.dx  = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,dx);
   else{
   mes.dy  = *p++;
   if (*p==-1)
      size = STRUCTSIZE(mes,dy);
   else{
   mes.co1 = *p++;
   if (*p==-1 || *p==0)
      size = STRUCTSIZE(mes,co1);
   else{
   s=(char*)*p++;
   strncpy(mes.data,(char *)s,MAX_MSG_TEXT);
   size=sizeof(mes)-MAX_MSG_TEXT+strlen(mes.data);
   if (size>sizeof(mes))
       size=sizeof(mes);
   }}}}}}}}}
/*   i=retries;
   do
   {
      res=msgsnd(queues[dq],&mes,size,IPC_NOWAIT);
      if (res!=-1)
         break;
      if (i)
         sleep(1);
   }
   while (i-->0);*/
   return Wsend(dq,&mes,size);
}


int Wsendncmd(int des,int cmd,int cid, int idx, int flg,int x, int y,int dx, int dy,int co1, int co2,
             char *data,int datalen)
{
   msg_win_cmd mes;
   int res,i;
/*   int *p,size,dq;
   char *s;*/

   Wlog(23,"Wsendcmd");
   if (queues[des]==-1)
   {
      queues[des]=msgget(BASEQUE+des,0666|IPC_CREAT);
      Wlog(1,"msgget %d,%d",queues[des],des);
   }
      
   mes.des = MSG_TYPCMD;   
   mes.pid = mypid;
   mes.cmd = cmd;
   mes.cid = cid;
   mes.idx = idx;
   mes.flg = flg;
   mes.x   = x;
   mes.y   = y;
   mes.dx  = dx;
   mes.dy  = dy;
   mes.co1 = co1;
   mes.co2 = co2;
   if (data)
   {
      memcpy(mes.data,data,datalen);
   }   
   if (datalen>MAX_MSG_TEXT)
       datalen=MAX_MSG_TEXT;
   i=retries;
   do
   {
      res=msgsnd(queues[des],&mes,sizeof(mes)-MAX_MSG_TEXT+datalen,IPC_NOWAIT);
      if (res!=-1)
         break;
      sleep(1);
   }
   while (i-->0);
/*   Wlog(23,"WLIB %d,(%x,%x,%x,%x)",sizeof(mes)-MAX_MSG_TEXT+datalen,
           mes.data[0],mes.data[1],mes.data[2],mes.data[3]);*/
}

int Wretval(int pid, int cid,int idx)
{
   msg_win_cmd mes;
   int res,i;

/*   if (queues[pid]==-1)
   {
      queues[pid]=msgget(BASEQUE+pid,0666|IPC_CREAT);
      Wlog(1,"msgget %d,%d",queues[pid],pid);
   }*/
   mes.des = msg_to_ret;   
   mes.pid = mypid;
   mes.cmd =CMD_RETVAL;
   mes.cid =cid;
   mes.idx =idx;
   Wsend(pid,&mes,STRUCTSIZE(mes,idx));
/*   i=retries;
   do
   {
      res=msgsnd(queues[pid],&mes,STRUCTSIZE(mes,idx),IPC_NOWAIT);
      if (res!=-1)
         break;
      sleep(1);
   }
   while (i-->0);
   Wlog(1,"retmess %d(%d,%d,%d,%d,%d):%d=%d\n",  pid, mes.des , mes.pid , mes.cmd ,mes.cid,
   mes.idx, STRUCTSIZE(mes,idx),res);*/

    
}
/*
int Wsenddim(int des,int cmd,int cid, int flg, int dim[n],ENDD)
*/

int Wsenddim(int des,int cmd,int cid,...)
{
   msg_win_cmd mes;
   int *p;
   short *d;
   int res,i;
      
   mes.des = MSG_TYPDIM;   
   mes.pid = mypid;
   mes.cmd = cmd;
   mes.cid = cid;
   mes.flg = 0;
   d = &mes.flg;
   p=&cid;
   p++;
   for (i=0; i<MAXCMDDIM; i++)
   {
      if (*p==ENDD)
         break;
      *d++=*p++;
   }
   if (!i)
      d++;
   mes.idx = i;
   Wsend(des,&mes,(long)d-(long)&mes);
}

/*
int Wsenddat(int des,int cmd,int cid, char *data,int datalen, int flg, int dim[n],ENDD)
*/

int Wsenddat(int des,int cmd,int cid, char *data,int datalen,...)
{
   msg_win_cmd mes;
   int *p;
   short *d;
   int res,i;
      
   mes.des = MSG_TYPDIM;   
   mes.pid = mypid;
   mes.cmd = cmd;
   mes.cid = cid;
   mes.flg = 0;
   d = &mes.flg;
   p=&datalen;
   p++;
   for (i=0; i<MAXCMDDIM; i++)
   {
      if (*p==ENDD)
         break;
      *d++=*p++;
   }
   if (!i)
      d++;
   mes.idx = i;
   if (data)
   {
      if(!datalen)
         datalen = strlen(data)+1;
      if (datalen>MAX_MSG_TEXT)
         datalen=MAX_MSG_TEXT;
      memcpy(d,data,datalen);
   }
   else
      datalen = 0;
   Wsend(des,&mes,(long)d-(long)&mes+datalen);
   Wlog(52,"SENDDTA, %d %s.8",mes.x,d);
}

int Wsendmsg(int des,int cmd,int cid, int flg, int dim[],int dims, char *data,int datalen)
{
   msg_win_cmd mes;
   int *p;
   short *d;
   int res,i;
      
   mes.des = MSG_TYPDIM;   
   mes.pid = mypid;
   mes.cmd = cmd;
   mes.cid = cid;
   mes.flg = flg;
   d = &mes.x;
   p=dim;
   for (i=0; i<dims; i++)
      *d++=*p++;
   mes.idx = dims;
   if (data)
   {
      if(!datalen)
         datalen = strlen(data)+1;
      if (datalen>MAX_MSG_TEXT)
         datalen=MAX_MSG_TEXT;
      memcpy(d,data,datalen);
   }
   else
      datalen = 0;
   Wsend(des,&mes,(long)d-(long)&mes+datalen);
}

int Wretmsg(int cmd, int pid, int cid)
{
   msg_win_cmd mes;
   int res,i;

   if (queues[pid]==-1)
   {
      queues[pid]=msgget(BASEQUE+pid,0666|IPC_CREAT);
      Wlog(1,"msgget %d,%d",queues[pid],pid);
   }
   mes.des = msg_to_ret;   
   mes.pid = mypid;
   mes.cmd =cmd;
   mes.cid =cid;
   i=retries;
   do
   {
      res=msgsnd(queues[pid],&mes,STRUCTSIZE(mes,cid),IPC_NOWAIT);
      if (res!=-1)
         break;
      sleep(1);
   }
   while (i-->0);
    
}

int Wrecval(int cmd)
{
   msg_win_cmd mes;
   int ret,time;
   for (time=1;time<MAXWAITTIME;)
   {
      ret=msgrcv(queues[mypid],&mes,sizeof(mes),msg_to_ret,IPC_NOWAIT);
      if (ret<1)
      {
         usleep(time);
         time <<=1;
      }
      else if (mes.cmd == cmd)
         return(mes.cid);
      else 
         Wdefault_msg(&mes);
   }
   
   return(0);
   
}


int Wgetdim(msg_win_cmd *pmes, int idx)
{
   if (idx < 0)
      return 0 ;
   if (pmes->des == MSG_TYPDIM)
   {
      if (pmes->idx > idx)
         return *((short*)(&pmes->flg)+idx);
      else
         return 0;
   }        
   if (idx <= 4 )
      return *((short*)(&pmes->flg)+idx);
   else      
      return 0;
}

void *Wgetdata(msg_win_cmd *pmes,int *len)
{
   int dimlen,idx;
   
   if (pmes->des == MSG_TYPDIM)
   {
      idx = pmes->idx;
      if (idx<1)
          idx = 1; 
      dimlen = ((long)(&pmes->flg)-(long)pmes) + idx * sizeof(short);
      if ((*len -= dimlen)<0)
         *len =0;
      return (char*)(pmes)+dimlen;
   }
   *len -= STRUCTSIZE((*pmes),co2);
   return &pmes->data; 
}

int Wgetcmd(msg_win_cmd *mes)
{
   int wait,ret;
   if (mypid==-1)
      win_init();
   CLEAR(*mes);
   wait=0;
   if (timer || msg_to_rec != MSG_TYPALL)
      wait=IPC_NOWAIT;
   ret=msgrcv(queues[mypid],mes,sizeof(*mes),msg_to_rec,wait);
/*   if (ret>1)
      memset((char*)mes+ret,0,sizeof(*mes)-ret);*/
   if (ret<1 && timer>1)
      usleep(timer);
//   Wlog(43,"MSG: %d %d %d",msg_to_rec,mes->cmd,mes->cid,ret);
   return ret;
}

int Wgetretval()
{
   msg_win_cmd mes;
   int ret,time;
   for (time=1;time<MAXWAITTIME;)
   {
/*      Wlog(21,"WAIT FOR RETVAL %d %d",mypid,queues[mypid]);*/
      ret=msgrcv(queues[mypid],&mes,sizeof(mes),msg_to_ret,IPC_NOWAIT);
/*      Wlog(21,"RETVAL PID:%d CMD:%d",mes.pid,mes.cmd);*/
      if (ret<1)
      {
         usleep(time);
         time <<=1;
      }
      else if (mes.cmd == CMD_RETVAL)
         return(mes.cid);
   }
   
   return(0);
   
}

int Wdefault_msg(msg_win_cmd *pmes)
{

   switch (pmes->cmd)
   {
      case CMD_ACTCTL:
	 if (pmes->flg & 1)
	    Wactive = pmes->cid;
	 else
	 {
	    Wsendcmd(MAINQUE,CMD_ACTCTL,pmes->cid,0,0,PEND);
	    Wactive = 0;
	 }
	 break;
      case CMD_ADDKEY:
	 break;
      case CMD_UPDPTR:
         break;
      case CMD_DELTSK:
	 exit(0);
   }
}

int win_init()
{
   msg_win_cmd mes;
   
   if (!queues)
      Wqueinit();
   mypid=getpid();
   if(halt)
   {
      Wsendcmd(loaderqueue,CMD_PUTTSK,0,0,TSK_END,-1);
      exit(0);
   }
   else
   { 
      Wsendcmd(loaderqueue,CMD_PUTTSK,0,0,TSK_SINGLE,-1);
   }
   queues[STARTQUE]=msgget(BASEQUE+STARTQUE,0666|IPC_CREAT);
   Wlog(21,"startque %d ",queues[STARTQUE]);
   msg_to_ret = mypid;
   mypid = STARTQUE;   
   mypid=Wgetretval();
   msg_to_ret = MSG_TYPRET;
   queues[mypid]=msgget(BASEQUE+mypid,0666|IPC_CREAT);
   for(;msgrcv(queues[mypid],&mes,sizeof(mes),0,IPC_NOWAIT)!=-1;);
/*   mypid = STARTQUE;   
   mypid=Wgetretval(queues[STARTQUE],&mes,sizeof(mes),0,0);*/
/*   Wsendcmd(1,CMD_GETCTL,0,0,0,0,0,0,0,0,"");  /*not nessy*/
/*   myparent=Wgetretval();*/
   Wsendcmd(MAINQUE,CMD_INICTL,PEND);
   Wlog (42,"win_init %d",msg_to_rec);
/*   myparent=mes.cid;*/
   return(mypid);
}
/*
Wmsgloop(int action,int (msgprocess)())
{
   msg_win_cmd mes;
   int cid;
   
   if (!mypid)
      win_init();
   for(;;)
   {
      Wgetcmd(&mes);
      msgprocess(&mes);
   }

}
*/
int Wopenobj(char *str)
{
   int ret;
   Wsendcmd(1,CMD_ADDTSK,0,0,0,0,0,0,0,0,str);
   ret=Wgetretval();
   Wlog(1,"create_task %d\n",ret);
   return(ret);
}

Wqopen(int pid)
{
   msg_win_cmd mes;

   if (!queues)
      Wqueinit();
   queues[pid]=msgget(BASEQUE+pid,0666|IPC_CREAT);
   for(;msgrcv(queues[pid],&mes,sizeof(mes),0,IPC_NOWAIT)!=-1;);
}

Wdelque(int pid)
{ 
   if (queues[pid]!=-1)
      return(msgctl(queues[pid],IPC_RMID,NULL));
   return -1;
  
}
int Wqueinit()
{
    queues=malloc(maxqueues*sizeof(int));
    memset(queues,-1,maxqueues*sizeof(int));
}

Wsetpar(int parametr,int value)
{
     switch(parametr)
     {
     case PAR_MSGTYPE:
         msg_to_rec = value;
         break;
     case PAR_SENDLEVEL:
         msg_to_send = value;
         break;
     case PAR_TIMER:
         timer = value;
         break;
     case PAR_RETRY:
         retries = value;
         break;
     }
}


